
/** average completion time with two persons */

package applications;

import dataStructures.*;

public class AverageCompletionTime2
{
   // top-level nested classes  
   private static class Task implements Comparable
   {
      int id;         // job identifier
      int time;       // task time
      int person;     // person who is to do the task

      // constructor
      public Task(int theId, int theTime, int thePerson)
      {
         id = theId;
         time = theTime;
         person = thePerson;
      }

     // method of Comparable
     /** @return true iff this < x */
     public int compareTo(Object x)
     {
        int xTime = ((Task) x).time;
        if (time < xTime)
           return -1;
        if (time == xTime)
           return 0;
        return 1;
      }
  
     /** @return true iff this == x */
     public boolean equals(Object x)
        {return time == ((Task) x).time;}
   }

   /** assign the tasks task[1:task.length-1] to two persons
     * so that the average completion time is minimized
     * task to person assignment is done by setting task[].person */
   public static void minimizeAverageCompletionTime(Task [] task)
   {
      // sort into ascending order of task time
      HeapSort.heapSort(task);

      // assign tasks to persons in round-robin fashion
      for (int i = 1; i < task.length; i++)
         task[i].person = (i-1) % 2 + 1;
   }
   
   /** test program */
   public static void main(String [] args)
   {
      int n = 12;  // number of tasks
      Task [] theTask = new Task [n + 1];

      // create n tasks
      for (int i = 1; i <= n; i++)
         theTask[i] = new Task(i, 20 - i, 0);

      minimizeAverageCompletionTime(theTask);

      System.out.println("The tasks should be done in the order given below");
      for (int i = 1; i <= n; i++)
         System.out.println(theTask[i].id + " by person " + theTask[i].person);
   }
}
