

package applications;

import utilities.*;
import wrappers.*;

public class Binarize
{
   /** @return a two-dimensional boolean array b such that
     * b[i][j] is tru iff a[i][j] >= theThreshold */
   public static boolean [][] binarize(Comparable [][] a,
                                      Comparable theThreshold)
   {
      // create the answer array b
      boolean [][] b = new boolean [a.length][];
      for (int i = 0; i < a.length; i++)
      {
         // allocate a row of the answer array 
         // all initial values are false
         b[i] = new boolean [a[i].length];

         // change some values for this row to true
         for (int j = 0; j < a[i].length; j++)
            if (a[i][j].compareTo(theThreshold) >= 0)
               b[i][j] = true;
      }

      return b;
   }
   
   /** test program */
   public static void main(String [] args)
   {
      // initialize the data array
      int rows = 3,
          cols = 2;
      Integer [][] data = new Integer [rows][cols];
      for (int i = 0; i < rows; i++)
         for (int j = 0; j < cols; j++)
            data[i][j] = new Integer(i * rows + j);
      Integer threshold = new Integer(2);

      // output the data and the threshold
      for (int i = 0; i < rows; i++)
      {
         for (int j = 0; j < cols; j++)
            System.out.print(data[i][j] + " ");
         System.out.println();
      }
      System.out.println("Threshold = " + threshold);

      // binarize
      boolean [][] answer = binarize(data, threshold);
 
      // output the answer
      for (int i = 0; i < rows; i++)
      {
         for (int j = 0; j < cols; j++)
            System.out.print(answer[i][j] + " ");
         System.out.println();
      }
   }
}
