   
/** compute change using greedy method of Example 18.4 */

package applications;

import utilities.*;
import exceptions.*;

public class ChangeMaker
{
   /** input amount of purchase and amount tendered,
     * @return amount of change to be given */
   public static Currency input(MyInputStream inStream)
   {
      System.out.println("Enter the purchase amount as xxx.yy");
      float purchase = inStream.readFloat();
      if (purchase <= 0)
         throw new MyInputException
                   ("purchase amount must be > 0.00");
   
      System.out.println("Enter the amount tendered as xxx.yy");
      float tendered = inStream.readFloat();
      if (tendered < purchase)
         throw new MyInputException
                   ("purchase amount must be >= purchase amount");
   
      return new Currency(tendered - purchase);
   }
   
   /** compute and output change denominations that amount to theChange */
   public static void output(Currency theChange)
   {
      System.out.println("The change amount is " + theChange);
      System.out.println("This is to be given in the following way:");
   
      // first handle the bills
      long dollars = theChange.getDollars();
      
      if (dollars >= 100)
      {// need $100 bills
         System.out.println(dollars / 100 + " x $100");
         dollars %= 100;
      }
      
      if (dollars >= 50) 
      {// need $50 bills
         System.out.println(dollars / 50 + " x $50");
         dollars %= 50;
      }
      
      if (dollars >= 20) 
      {// need $20 bills
         System.out.println(dollars / 20 + " x $20");
         dollars %= 20;
      }
      
      if (dollars >= 5) 
      {// need $5 bills
         System.out.println(dollars / 5 + " x $5");
         dollars %= 5;
      }
      
      if (dollars >= 1) 
      // need $1 bills
         System.out.println(dollars + " x $1");
      
      // now handle the coins
      int cents = theChange.getCents();
      
      if (cents >= 25) 
      {// need quarters
         System.out.println(cents / 25 + " x quarters");
         cents %= 25;
      }
      
      if (cents >= 10) 
      {// need dimes
         System.out.println(cents / 10 + " x dimes");
         cents %= 10;
      }
      
      if (cents >= 5) 
      {// need nickels
         System.out.println(cents / 5 + " x nickels");
         cents %= 5;
      }
      
      if (cents >= 1) 
      // need pennies
         System.out.println(cents + " x pennies");
   }
   
   /** test ChangeMaker */
   public static void main(String [] args)
   {
      // define the input stream to be the standard input stream
      MyInputStream keyboard = new MyInputStream();

      // try three transactions
      for (int i = 1; i <= 3; i++)
         try
         {
            Currency c = input(keyboard);
            output(c);
         }
         catch (Exception e)
            {System.out.println("An exception has occurred");}
   }
}
