/** Enhancement of Currency to include the methods input,
  * subtract, percent, multiply, and divide */

package applications;

import utilities.*;

public class EnhancedCurrency extends Currency
{
   // same constructors as in super class
   public EnhancedCurrency(boolean theSign, long theDollars, byte theCents)
      {super(theSign, theDollars, theCents);}

   public EnhancedCurrency()
      {super();}

   public EnhancedCurrency(double theValue)
      {super(theValue);}

   // new instance methods
   public void input()
   {
      // define the input stream to be the standard input stream
      MyInputStream keyboard = new MyInputStream();

      // input the amount as a double
      System.out.println("Enter the currency amount as a real number");
      double theValue = keyboard.readDouble();

      // set the value
      setValue(theValue);
   }

   /** return this - x */
   public EnhancedCurrency subtract(EnhancedCurrency x)
   {
      // convert this to a long
      long a1 = getDollars() * 100 + getCents();
      if (getSign() == MINUS) a1 = -a1;
      
      // convert x to a long
      long a2 = x.getDollars() * 100 + x.getCents();
      if (x.getSign() == MINUS) a2 = -a2;
      
      long a3 = a1 - a2;
       
      // convert result to EnhancedCurrency object
      EnhancedCurrency answer = new EnhancedCurrency();
      if (a3 < 0)
      {
         answer.setSign(MINUS);
         a3 = -a3;
      }
      else
         answer.setSign(PLUS);
      answer.setDollars(a3 / 100);
      answer.setCents((byte) (a3 - answer.getDollars() * 100));
      
      return answer;
   }

   /** return x percent of this */
   public EnhancedCurrency percent(float x)
   {
      long a1, a2;
      // convert this to a long
      a1 = getDollars() * 100 + getCents();
      if (getSign() == MINUS) a1 = -a1;
      
      a2 = (long) (a1 * x / 100);
       
      // convert result to Currency object
      EnhancedCurrency answer = new EnhancedCurrency();
      if (a2 < 0)
      {
         answer.setSign(MINUS);
         a2 = -a2;
      }
      else
         answer.setSign(PLUS);
      answer.setDollars(a2 / 100);
      answer.setCents((byte) (a2 - answer.getDollars() * 100));
      
      return answer;
   }

   /** return this * x */
   public EnhancedCurrency multiply(float x)
   {
      long a1, a2;
      // convert this to a long
      a1 = getDollars() * 100 + getCents();
      if (getSign() == MINUS) a1 = -a1;
      
      a2 = (long) (a1 * x);
       
      // convert result to Currency object
      EnhancedCurrency answer = new EnhancedCurrency();
      if (a2 < 0)
      {
         answer.setSign(MINUS);
         a2 = -a2;
      }
      else
         answer.setSign(PLUS);
      answer.setDollars(a2 / 100);
      answer.setCents((byte) (a2 - answer.getDollars() * 100));
      
      return answer;
   }

   /** return this / x */
   public EnhancedCurrency divide(float x)
   {
      long a1, a2;
      // convert this to a long
      a1 = getDollars() * 100 + getCents();
      if (getSign() == MINUS) a1 = -a1;
      
      a2 = (long) (a1 / x);
       
      // convert result to Currency object
      EnhancedCurrency answer = new EnhancedCurrency();
      if (a2 < 0)
      {
         answer.setSign(MINUS);
         a2 = -a2;
      }
      else
         answer.setSign(PLUS);
      answer.setDollars(a2 / 100);
      answer.setCents((byte) (a2 - answer.getDollars() * 100));
      
      return answer;
   }

   /** test program */
   public static void main(String [] args)
   {
      EnhancedCurrency g = new EnhancedCurrency(),
                       h = new EnhancedCurrency(PLUS, 3L, (byte) 50),
                       i = new EnhancedCurrency(2.50),
                       j = new EnhancedCurrency();

      // test input
      j.input();
      System.out.println("The input value is " + j);
      
      // test remaining new methods
      System.out.println(h + " - " + i + " = " + h.subtract(i));
      System.out.println("10 percent of " + i + " is " + i.percent(10.0F));
      System.out.println("2 * " + i + " = " + i.multiply(2.0F));
      System.out.println(i + " / 5 = " + i.divide(5.0F));
   }
}
