
/** recursive and iterative codes to compute a Fibonacci number */

package applications;

public class Fibonacci
{
   /** recursive method to return the n'th Fibonacci number, n >= 0 */
   public static int recursiveFibonacci(int n)
   {
      if (n == 0)
         return 0;
      if (n == 1)
         return 1;
      return recursiveFibonacci(n - 1) + recursiveFibonacci(n - 2);
   }
   
   /** nonrecursive code to return the n'th Fibonacci number, n >= 0 */
   public static int fibonacci(int n)
   {
      if (n == 0)
         return 0;
      if (n == 1)
         return 1;
      int secondLast = 0;  // second last Fibonacci number
                           // computed so far
      int last = 1;        // last Fibonacci number
                           // computed so far
      // compute new numbers
      for (int i = 2; i <= n; i++)
      {
         // compute i'th Fibonacci number
         int next = last + secondLast;
         // update last and secondLast
         secondLast = last;
         last = next;
      }
   
      return last;
   }
   
   /** test program */
   public static void main(String [] args)
   {
      // test recursive method
      System.out.println("The 2nd Fibonacci number is "
           + recursiveFibonacci(2));
   
      System.out.println("The 3rd Fibonacci number is "
           + recursiveFibonacci(3));
   
      System.out.println("The 4th Fibonacci number is "
           + recursiveFibonacci(4));
   
      System.out.println("The 5th Fibonacci number is "
           + recursiveFibonacci(5));

      // test iterative method
      System.out.println("The 2nd Fibonacci number is "
           + fibonacci(2));
   
      System.out.println("The 3rd Fibonacci number is "
           + fibonacci(3));
   
      System.out.println("The 4th Fibonacci number is "
           + fibonacci(4));
   
      System.out.println("The 5th Fibonacci number is "
           + fibonacci(5));
   }
}
