package applications;

public class GrayCode
{

   /** @return the bit change sequence for the n bit gray code 
     * @throws IllegalArgumentException when n < 1 */
   private static String grayCode(int n)
   {
      if (n < 1)
         throw new IllegalArgumentException(" n must be >= 1, it is "
                                            + n);
      return g(n);
   }

   /** @return the bit change sequence for the n bit gray code */
   private static String g(int n)
   {
      if (n == 1)
         return "1";
      
      String left = g(n - 1);
      return left + ", " + n + ", " + left;
   }
   
   public static void main(String [] args)
   {
      System.out.println("g(1) = " + grayCode(1));
      System.out.println("g(2) = " + grayCode(2));
      System.out.println("g(3) = " + grayCode(3));
   }
}
