
package applications;

public class Square
{

   // instance data member
   double length;

   // constructors
   /** create a square whose length is theLength 
     * @throws IllegalArgumentException when theLength < 0 */
   public Square(double theLength)
   {
      if (theLength < 0)
         throw new IllegalArgumentException
               ("length must be >= 0, you have specified " + theLength);

      length = theLength;
   }

   /** create a square whose length is 0 */
   public Square() {};

   // instance methods
   /** @return the length of the square */
   public double getLength()
      {return length;}

   /** set the length of the square to theLength */
   public void setLength(double theLength)
   {
      if (theLength < 0)
         throw new IllegalArgumentException
               ("length must be >= 0, you have specified " + theLength);

      length = theLength;
   }

   /** @return area of the square */
   public double area()
      {return length * length;}

   /** @return perimeter of the square */
   public double perimeter()
      {return 4 * length;}

   /** print the square length */
   public void outputLength()
      {System.out.println("The length is " + length);}

   /** print the area and perimeter */
   public void printAP()
   {
      System.out.println("The area is " + area());
      System.out.println("The perimeter is " + perimeter());
   }

   /** test program */
   public static void main(String [] args)
   {
      // test constructors
      Square g = new Square(),
             h = new Square(2.0);

      g.outputLength();
      g.printAP();
      h.outputLength();
      h.printAP();
      System.out.println("The length is " + h.getLength());
      h.setLength(4.0);
      System.out.println("The length is now " + h.getLength());

   }
}
