
package applications;

import java.util.*;

public class SquareTrack extends Square
{

   // instance data member
   double trackWidth;

   // constructors
   /** create a square track whose length is theLength and whose
     * width is theTrackWidth
     * @throws IllegalArgumentException when theLength < 0 or
     * theTrackWidth < 0, or theTrackWidth > theLength / 2 */
   public SquareTrack(double theLength, double theTrackWidth)
   {
      super(theLength);

      if (theTrackWidth < 0)
         throw new IllegalArgumentException
               ("track width must be >= 0, you have specified "
                + theTrackWidth);

      if (theTrackWidth > length / 2)
         throw new IllegalArgumentException
               ("track width must be <= " + (length / 2)
                + ", you have specified " + theTrackWidth);

      trackWidth = theTrackWidth;
   }

   // instance methods
   /** @return the track width */
   public double getrackWidth()
      {return trackWidth;}

   /** override super.setLength */
   public void setLength(double theLength)
   {
         throw new UnsupportedOperationException
               ("cannot set length independent of width");
   }

   /** set the track length to theLength and width to theTrackWidth */
   public void setLengthAndWidth(double theLength, double theTrackWidth)
   {

      super.setLength(theLength);

      if (theTrackWidth < 0)
         throw new IllegalArgumentException
               ("track width must be >= 0, you have specified "
                + theTrackWidth);

      if (theTrackWidth > length / 2)
         throw new IllegalArgumentException
               ("track width must be <= " + (length / 2)
                + ", you have specified " + theTrackWidth);

      trackWidth = theTrackWidth;
   }

   /** @return area of the track */
   public double area()
      {return 4 * trackWidth * (length - trackWidth);}

   /** @return perimeter of the track */
   public double perimeter()
      {return 8 * (length - trackWidth);}

   /** print the track width */
   public void outputTrackWidth()
      {System.out.println("The track width is " + trackWidth);}

   /** test program */
   public static void main(String [] args)
   {
      // test constructor
      SquareTrack g = new SquareTrack(8.0, 2.0);

      g.outputLength();
      g.outputTrackWidth();
      g.printAP();
      g.setLengthAndWidth(4.0, 1.0);
      g.outputLength();
      g.outputTrackWidth();
   }
}
