

/** sum of subsets problem */

package applications;

public class SubsetSum
{
   // class data members
   static int numberOfContainers;
   static int [] currentSubset;
   static int [] weight;
   static int targetSum;
   static int currentSum;
   static int remainingSum;

   
   /** @param theWeight[1..theWeight.length - 1] is array of weights
     * @param theTargetSum is target sum
     * @param theSubset theSubset[i] is set to 1 iff weight i is
     * in the subset whose sum is theTargetSum
     * @return true iff there is a subset whose sum equals theTargetSum */
   public static boolean subsetSum(int [] theWeight, int theTargetSum,
                                   int [] theSubset)
   {
      // initialize class data members
      numberOfContainers = theWeight.length - 1;
      currentSubset = theSubset;
      weight = theWeight;
      targetSum = theTargetSum;
      currentSum = 0;
      // initial remainingSum is sum of all weights
      remainingSum = 0;
      for (int i = 1; i <= numberOfContainers; i++) 
         remainingSum += weight[i];
   
      return rSum(1);
   }

   /** search from a level currentLevel node for a
     * subset whose sum is targetSum - currentSum
     * set currentSubset[currentLevel] = 1 iff object currentLevel
     * in this subset
     * @return true when this subset has been found */
   private static boolean rSum(int currentLevel)
   {
      if (currentLevel > numberOfContainers)
         // at a leaf that has the desired sum
         return true;

      // check subtrees
      remainingSum -= weight[currentLevel];
      if (currentSum + weight[currentLevel] <= targetSum)
      {// try currentSubset[currentLevel] = 1
         currentSum += weight[currentLevel];
         if (rSum(currentLevel + 1))
         {// found a subset with desired sum
            currentSubset[currentLevel] = 1;
            return true;
         }
         currentSum -= weight[currentLevel];
      }

      if (currentSum + remainingSum >= targetSum)
         // try currentSubset[currentLevel] = 0
         if (rSum(currentLevel + 1))
         {// found the subset with desired sum
            currentSubset[currentLevel] = 0;
            return true;
         }

      remainingSum += weight[currentLevel];
      return false;
   }
   
   /** test sum of subsets */
   public static void main(String [] args)
   {
      int n = 5;
      int [] w = {0, 2, 2, 4, 5, 6};
      int [] x = new int [6];
      int c = 11;

      if (subsetSum(w, c, x))
      {
         System.out.println("There is a subset with desired sum");
         System.out.println("x values are");
         for (int i=1; i<=n; i++)
            System.out.print(x[i] + " ");
         System.out.println();
      }
      else
         System.out.println("No subset has the desired sum");
   }
}
