// Towers of Hanoi with red and yellow disks

package applications;

public class TowersOfHaHa
{
   /** output a sequence of disk moves for the Towers of HaHa problem
     * @param n number of disks
     * @param x source tower
     * @param y destination tower
     * @param z intermediate tower */
   public static void towersOfHaHa(int n, int x, int y, int z)
   {// Move the top n disks from tower x to tower y.
    // Use tower z for intermediate storage.
       // first move all disks to the intermediate tower   
       // this move reverses the disk order
       for (int i = 1; i <= n; i++)
          System.out.println("Move disk " + i + " from tower " + x +
                             " to top of tower " + z);

       // now move all disks to the destination tower   
       // this move restores the disk order
       for (int i = n; i > 0; i--)
          System.out.println("Move disk " + i + " from tower " + z +
                             " to top of tower " + y);
   }
   
   /** test program */
   public static void main(String [] args)
   {
      System.out.println("Moves for a three disk problem are");

      // move 3 disks from tower 1 to tower 2 using tower 3
      // as the intermediate tower
      towersOfHaHa(3, 1, 2, 3);
   }
}
