/** sort using a binary search tree */

package applications;

import java.lang.reflect.*;
import dataStructures.*;

public class TreeSort
{
   static Comparable [] theArray;  // array to put sorted elements
   static int n;                   // number of elements in theArray

   /** visit method that adds an element to theArray */
   public static void addToArray(BinaryTreeNode x)
      {theArray[n++] = (Comparable) 
                        ElementInBinarySearchTreeNode.getElement(x);}

   // define a Method variable for adding to an array
   static Class [] paramType = {BinaryTreeNode.class};
                             // type of parameter for visit
   static Method theAddToArray;

   // initialize theAddToArray
   static
   { 
      try
      {
         Class lbt = TreeSort.class;
         theAddToArray = lbt.getMethod("addToArray", paramType);
      }
      catch (Exception e) {}
         // exception not possible
   }

   /** sort a[0:a.length-1] */
   public static void treeSort(Comparable [] a)
   {

      // create a binary search tree and insert the array elements into it
      BinarySearchTree tree = new BinarySearchTree();
      for (int i = 0; i < a.length; i++)
         tree.put(a[i], a[i]);

      // collect in sorted order from the tree
      theArray = a;   // array to collect elements in
      n = 0;          // current number of elements in theArray
      tree.inOrder(theAddToArray);
   }

   /** test program */
   public static void main(String [] args)
   {
      Integer [] a = {new Integer(3),
                        new Integer(2),
                        new Integer(4),
                        new Integer(1),
                        new Integer(6),
                        new Integer(9),
                        new Integer(8),
                        new Integer(7),
                        new Integer(5),
                        new Integer(0)};

      // output elements to be sorted
      System.out.println("The elements are");
      for (int i = 0; i < a.length; i++)
         System.out.print(a[i] + " ");
      System.out.println();

      // sort the elements
      treeSort(a);

      // output in sorted order
      System.out.println("The sorted order is");
      for (int i = 0; i < a.length; i++)
         System.out.print(a[i] + " ");
      System.out.println();
   }
}
