/** AdjacencyDigraph extension that includes depth-first search */

package dataStructures;

import java.util.*;
import utilities.*;

public class AdjacencyDigraphWithDfs extends AdjacencyDigraph
{
   // constructors
   public AdjacencyDigraphWithDfs(int theVertices)
      {super(theVertices);}
   
   // default is a 0-vertex graph
   public AdjacencyDigraphWithDfs()
      {this(0);}
   
   /** depth-first search
     * reach[i] is set to label for all vertices reachable
     * from vertex v */
   static int [] reach;
   static int label;
   public void dfs(int v, int [] reach, int label)
   {
      AdjacencyDigraphWithDfs.reach = reach;
      AdjacencyDigraphWithDfs.label = label;
      rDfs(v);
   }
   
   /** recursive dfs method */
   private void rDfs(int v)
   {
      reach[v] = label;
      // go down the adjacency matrix row for vertex v
      for (int u = 1; u <= n; u++)
         if (a[v][u] && reach[u] == 0)
            // u is an unreached but reachable vertex
            rDfs(u);
   }

   public static void main(String [] args)
   {
      AdjacencyDigraphWithDfs g = new AdjacencyDigraphWithDfs(7);
      int n = 7;
      int [] reach = new int [n + 1];

      // define a MyInputStream object to input from System.in
      MyInputStream keyboard = new MyInputStream();

      // input a test graph
      System.out.println("enter number of edges in graph");
      int e = keyboard.readInteger();
      for (int i = 1; i <= e; i++)
      {
         System.out.println("enter edge " + i);
         int u = keyboard.readInteger();
         int v = keyboard.readInteger();
         g.putEdge(new Edge(u, v));
      }
      System.out.println("The digraph is");
      g.output();

      g.dfs(1, reach, 1);
      System.out.print("Reached values for vertices are ");
      for (int j = 1; j <= n; j++)
         System.out.print(reach[j] + " ");
      System.out.println();
   }
}
