
/** preorder traversal of an array-based binary tree */

package dataStructures;

public class ArrayBinaryTreeWithPreorder
{
   // data members
   static Object [] a;   // array that contains the tree
   static int last;      // position of last element in array a

   /** visit method that prints the element in a[i] */ 
   public static void visit(int i)
      {System.out.print(a[i] + " ");}


   /** preorder traversal */
   public static void preOrder(Object [] theArray, int theLast)
   {
      // set static data members
      a = theArray;
      last = theLast;

      // start the recursive traversal method at the root
      thePreOrder(1);
   }

   /** actual method to do the preorder traversal */
   static void thePreOrder(int i)
   {// traverse subtree rooted at a[i]
      if (i <= last && a[i] != null)
      {// root exists
         visit(i);                   // visit tree root
         thePreOrder(2 * i);         // do left subtree
         thePreOrder(2 * i + 1);     // do right subtree
      }
   }

   /** test program */
   public static void main(String [] args)
   {
      Integer [] a = new Integer [15];
      a[1] = new Integer(1);
      a[2] = new Integer(2);
      a[5] = new Integer(5);
      a[10] = new Integer(10);
      a[11] = new Integer(11);

      System.out.println("The elements in preorder are");
      preOrder(a, 11);
      System.out.println();
   }
}
