

/** extension of ArrayLinearList to include the method clear */

package dataStructures;

import utilities.*;

public class ArrayLinearListWithClear extends ArrayLinearList
{
   // constructors
   public ArrayLinearListWithClear(int initialCapacity)
      {super(initialCapacity);}

   public ArrayLinearListWithClear()
   {// use default capacity of 10
      this(10);
   }

   /** make the list empty */
   public void clear()
   {
      while (size > 0)
         element[--size] = null;   // enable garbage collecition
   }   

   /** test program */
   public static void main(String [] args)
   {
      ArrayLinearListWithClear x = new ArrayLinearListWithClear(1);

      x.add(0, new Integer(0));
      x.add(1, new Integer(1));
      System.out.println("List size is " + x.size());
      System.out.println("The list is " + x);
      System.out.println();

      x.clear();
      System.out.println("List size is " + x.size());
      System.out.println("The list is " + x);
   }
}
