
/** clone a linear list represented using Equation 5.1
  * each element in the list is also cloned */

package dataStructures;

import wrappers.*;
import utilities.*;

public class ArrayLinearListWithClone
       extends ArrayLinearList
       implements CloneableObject
{
   /** @return a clone of the linear list */
   public Object clone()
   {// overrides Object.clone()
      ArrayLinearListWithClone x =
                        new ArrayLinearListWithClone(); 
      x.size = size;
      x.element = new Object [element.length];
      for (int i = 0; i < size; i++)
         x.element[i] = (element[i] == null) ? null :
                         ((CloneableObject) element[i]).clone();

      return x;
   }


   /** test program */
   public static void main(String [] args)
   {
      int n = 10;
      ArrayLinearListWithClone x =
         new ArrayLinearListWithClone();
      ArrayLinearListWithClone y =
         new ArrayLinearListWithClone();
      
      //  put elements in x
      for (int i = 0; i < n; i++)
         x.add(0, new MyInteger(i));
      
      System.out.println("The clone of " + x + " is ");
      y = (ArrayLinearListWithClone) x.clone();
      System.out.println(y);
      x.add(2, new MyInteger(3));
      System.out.println("Changed original, clone should be unchanged.");
      System.out.println("Clone is " + y);
   }
}
