

/** extension of ArrayLinearList to include the method lastIndexOf */

package dataStructures;

import utilities.*;

public class ArrayLinearListWithLastIndexOf extends ArrayLinearList
{
   // constructors
   public ArrayLinearListWithLastIndexOf(int initialCapacity)
      {super(initialCapacity);}

   public ArrayLinearListWithLastIndexOf()
   {// use default capacity of 10
      this(10);
   }
   
   /** @return index of last occurrence of theElement,
     * return -1 if theElement not in list */
   public int lastIndexOf(Object theElement)
   {
      // search element[] for theElement
      for (int i = size - 1; i >= 0; i--)
         if (element[i].equals(theElement))
            return i;

      // theElement not found
      return -1;
   }      

   /** test program */
   public static void main(String [] args)
   {
      ArrayLinearListWithLastIndexOf x = new ArrayLinearListWithLastIndexOf(1);

      x.add(0, new Integer(0));
      x.add(1, new Integer(1));
      x.add(2, new Integer(1));
      x.add(3, new Integer(0));
      System.out.println("List size is " + x.size());
      System.out.println("The list is " + x);
      System.out.println();

      System.out.println("First occurrence of 0 is "
                         + x.indexOf(new Integer(0)));
      System.out.println("First occurrence of 1 is "
                         + x.indexOf(new Integer(1)));
      System.out.println("Last occurrence of 0 is "
                         + x.lastIndexOf(new Integer(0)));
      System.out.println("Last occurrence of 1 is "
                         + x.lastIndexOf(new Integer(1)));
      System.out.println("Last occurrence of 2 is "
                         + x.lastIndexOf(new Integer(2)));
   }
}
