/** meld two linear lists */

package dataStructures;

public class ArrayLinearListWithMeld
       extends ArrayLinearList
{
   /** make this the result of melding the lists a and b,
     * i.e., take elements alternately from a and b */
   public void meld(ArrayLinearListWithMeld a,
                     ArrayLinearListWithMeld b)
   {
      // compute size of result
      size = a.size + b.size;

      // get big enough array for result
      // if you opt to do this only when a.size + b.size > element.length,
      // be sure to set element[a.size + b.size : this.oldSize] to null
      // to enable garbage collection
      element = new Object [size];

      int ct = 0;                        // cursor for this
      int s = Math.min(a.size, b.size);  // smaller of a.size and b.size
      
      // copy s elements from a and b to this
      for (int i = 0; i < s; i++)
      {
         element[ct++] = a.element[i];
         element[ct++] = b.element[i];
      }
      
      // take care of left overs (if any)
      for (int i = s; i < b.size; i++)
         element[ct++] = b.element[i];

      for (int i = s; i < a.size; i++)
         element[ct++] = a.element[i];

      // code to set excess elements of this.element to null
      // to enable garbage collection has been omitted
   }

   /** test program */
   public static void main(String [] args)
   {
      int n = 10, m = 5;
      ArrayLinearListWithMeld x = new ArrayLinearListWithMeld();
      ArrayLinearListWithMeld y = new ArrayLinearListWithMeld();
      ArrayLinearListWithMeld z = new ArrayLinearListWithMeld();
      
      //  put elements in x
      for (int i = 0; i < n; i++)
         x.add(0, new Integer(2 *(n - i)));
      
      //  put elements in y
      for (int i = 0; i < m; i++)
         y.add(0, new Integer(2 * (n - i)));
      
      System.out.println("First list is " + x);
      System.out.println("Second list is " + y);
      z.meld(x, y);
      System.out.println("Melded list is " + z);
      z.meld(y, x);
      System.out.println("Melded list is " + z);
   }
}
