/** split an array-based linear list into two */

package dataStructures;

public class ArrayLinearListWithSplit
       extends ArrayLinearList
{
   /** split this into lists a and b */
   public void split(ArrayLinearListWithSplit a,
                     ArrayLinearListWithSplit b)
   {
      // compute size of each split list, note that b.size
      // is 1 less than a.size when this.size is odd
      b.size = size / 2;
      a.size = size - b.size;

      // get large enough arrays
      a.element = new Object [a.size];
      b.element = new Object [b.size];
      
      int ct = 0;         // cursor for this
      for (int i = 0; i < b.size; i++)
      {
         a.element[i] = element[ct++];
         b.element[i] = element[ct++];
      }
      
      // is an element left?
      if (a.size > b.size)
         a.element[a.size - 1] = element[ct];
   }

   /** test program */
   public static void main(String [] args)
   {
      ArrayLinearListWithSplit x =
                  new ArrayLinearListWithSplit();
      ArrayLinearListWithSplit y =
                  new ArrayLinearListWithSplit();
      ArrayLinearListWithSplit z =
                  new ArrayLinearListWithSplit();
      
      //  first try a list with even size
      int n = 10;
      // put elements in x
      for (int i = 0; i < n; i++)
         x.add(i, new Integer(i));
      
      System.out.println("The list is " + x);
      x.split(y, z);
      System.out.println("The split lists are " + y + "\nand " + z);
      System.out.println();
      
      //  now try a list with odd size
      // put one more element into x
      x.add(n, new Integer(n));
      
      System.out.println("The list is " + x);
      x.split(y, z);
      System.out.println("The split lists are " + y + "\nand " + z);
      System.out.println();
   }
}
