
/** linked binary trees with outputInRange method */

package dataStructures;

public class BinarySearchTreeWithOutputInRange extends BinarySearchTree
{
   // class data members
   static Comparable low;
   static Comparable high;

   /** output all elements with keys between theLow and theHigh */
   public void outputInRange(Comparable theLow, Comparable theHigh)
   {
      low = theLow;
      high = theHigh;
      System.out.println("The elements whose keys are between " + low
                          + " and " + high + " are");
      outputInRange(root);
      System.out.println();
   }
   
   /** output elements between low and high in subtree rooted at t */
   static void outputInRange(BinaryTreeNode t)
   {
      if (t == null)
         // empty tree, no elements to output
         return;
   
      if (low.compareTo(((Data) t.element).key) < 0)
         // left subtree may have some keys in the range
         outputInRange(t.leftChild);
   
      if (low.compareTo(((Data) t.element).key) <= 0 &&
          high.compareTo(((Data) t.element).key) >= 0)
         // element in t is to be output
         System.out.print(((Data) t.element).element + " ");


      if (high.compareTo(((Data) t.element).key) > 0)
         // right subtree may have some keys in the range
         outputInRange(t.rightChild);
   }

   /** test program */
   public static void main(String [] args)
   {
      BinarySearchTreeWithOutputInRange y =
                      new BinarySearchTreeWithOutputInRange();
    
      // insert a few elements
      y.put(new Integer(1), new Character('a'));
      y.put(new Integer(6), new Character('f'));
      y.put(new Integer(4), new Character('d'));
      y.put(new Integer(8), new Character('h'));
      y.put(new Integer(2), new Character('b'));
      y.put(new Integer(5), new Character('e'));
      y.put(new Integer(7), new Character('g'));
      y.put(new Integer(3), new Character('c'));
      System.out.println("Elements in ascending order are");
      y.ascend();
      System.out.println();

      y.outputInRange(new Integer(3), new Integer(7));
      y.outputInRange(new Integer(0), new Integer(17));
      y.outputInRange(new Integer(6), new Integer(6));
      y.outputInRange(new Integer(6), new Integer(2));
   }
}
