
/** sort using a binary search tree */

package dataStructures;

public class BinarySearchTreeWithSort extends BinarySearchTree
{
   static Comparable [] theArray;  // array to put sorted elements
   static int n;                   // number of elements in theArray

   /** sort the array a[] by first putting the elements of a into a
     * binary search tree and then performing an inorder traversal
     * of the tree */
   public static void treeSort(Comparable [] a)
   {
      // create a binary search tree and insert the array elements into it
      BinarySearchTree tree = new BinarySearchTree();
      for (int i = 0; i < a.length; i++)
         tree.put(a[i], a[i]);   // may use any value, only key is important

      // collect in sorted order from the tree
      theArray = a;   // array to collect elements in
      n = 0;          // current number of elements in theArray
      toArray(tree.root);
   }

   /** collect elements from the search tree in inorder */
   static void toArray(BinaryTreeNode t)
   {
      if (t != null)
      {
         toArray(t.leftChild);                       // do left subtree
         theArray[n++] = ((Data) t.element).key;     // visit root
         toArray(t.rightChild);                      // do right subtree
      }
   }
   

   /** test program */
   public static void main(String [] args)
   {
      Integer [] a = {new Integer(3),
                        new Integer(2),
                        new Integer(4),
                        new Integer(1),
                        new Integer(6),
                        new Integer(9),
                        new Integer(8),
                        new Integer(7),
                        new Integer(5),
                        new Integer(0)};

      // output elements to be sorted
      System.out.println("The elements are");
      for (int i = 0; i < a.length; i++)
         System.out.print(a[i] + " ");
      System.out.println();

      // sort the elements
      treeSort(a);

      // output in sorted order
      System.out.println("The sorted order is");
      for (int i = 0; i < a.length; i++)
         System.out.print(a[i] + " ");
      System.out.println();
   }
}
