
/** clone a chain, each element in the chain is also cloned */

package dataStructures;

import utilities.*;
import wrappers.*;

public class ChainWithClone
             extends Chain
             implements CloneableObject
{
   /** @return a clone of the linear list */
   public Object clone()
   {// overrides Object.clone()
      // create an empty chain
      ChainWithClone x = new ChainWithClone();

      ChainNode currentNode = firstNode;
                    // current node of chain to be cloned
      ChainNode lastNode = null;  // last node of new chain
      while (currentNode != null)
      {// clone this node
         ChainNode p =
              new ChainNode(((CloneableObject) currentNode.element).clone());
         // link to last node
         if (lastNode != null)
            lastNode.next = p;
         else
            x.firstNode = p;  // p is first node of new chain
         lastNode = p;

         // advance to next node of chain being cloned
         currentNode = currentNode.next;
      }
   
      // take care of last node of new chain
      if (lastNode != null)
         lastNode.next = null;

      x.size = size;
      return x;
   }


   /** test program */
   public static void main(String [] args)
   {
      int n = 10;
      ChainWithClone x =
         new ChainWithClone();
      
      //  put elements in x
      for (int i = 0; i < n; i++)
         x.add(0, new MyInteger(i));
      
      System.out.println("The clone of " + x + " is ");
      ChainWithClone y = (ChainWithClone) x.clone();
      System.out.println(y);
      x.add(2, new MyInteger(3));
      System.out.println("Changed original, clone should be unchanged.");
      System.out.println("Clone is " + y);
   }
}
