
/** extension of Chain to include the method leftShift */

package dataStructures;

public class ChainWithLeftShift extends Chain
{
   /** shift elements left by amountOfShift
     * @throws IllegalArgumentException when amountOfShift < 0 */
   public void leftShift(int amountOfShift)
   {
      // empty list is easily shifted by any amount
      if (size == 0)
         return;

      // validate shift amount
      if (amountOfShift < 0)
         throw new IllegalArgumentException("shift amount must be >= 0,"
                          + " you have specified " + amountOfShift);

      if (amountOfShift < size)
      {// nonempty list remains
          // eliminate from front
          for (int i = 0; i < amountOfShift; i++)
             firstNode = firstNode.next;
          size -= amountOfShift;
      }
      else
      {// empty list remains
          firstNode = null;
          size = 0;
      }
   }
     

   /** test program */
   public static void main(String [] args)
   {
      ChainWithLeftShift x = new ChainWithLeftShift();

      x.add(0, new Integer(0));
      x.add(1, new Integer(1));
      x.add(2, new Integer(2));
      x.add(3, new Integer(3));
      x.add(4, new Integer(4));
      x.add(5, new Integer(5));
      x.add(6, new Integer(6));
      System.out.println("List size is " + x.size());
      System.out.println("The list is " + x);

      x.leftShift(1);
      System.out.println("Shifted by 1");
      System.out.println("List size is " + x.size());
      System.out.println("The list is " + x);

      x.leftShift(3);
      System.out.println("Shifted by 3");
      System.out.println("List size is " + x.size());
      System.out.println("The list is " + x);

      x.leftShift(10);
      System.out.println("Shifted by 10");
      System.out.println("List size is " + x.size());
      System.out.println("The list is " + x);
   }
}
