package dataStructures;

public class ChainWithOneFourth extends Chain
{
   /** remove every element other than every fourth element */
   public void oneFourth()
   {
      ChainNode lastNode = null;      // last node resulting chain
      ChainNode currentNode = firstNode;
      size /= 4;                      // final size of chain
      for (int i = 0; i < size; i++)
      {// get next element that is to be saved
         ChainNode nodeToSave = currentNode.next.next.next;
         if (lastNode == null)
            // first node being saved
            firstNode = nodeToSave;
         else
            // not first node to save
            lastNode.next = nodeToSave;
         lastNode = nodeToSave;
         currentNode = nodeToSave.next;
      }

      // set next field of last node
      if (lastNode == null)
         firstNode = null;
      else
         lastNode.next = null;
   }

   public static void main(String [] args)
   {
      int n = 10;
      ChainWithOneFourth x = new ChainWithOneFourth();
      
      //  put elements in x
      for (int i = 0; i < n; i++)
         x.add(0, new Integer(2 * (n - i)));
      
      System.out.println("Chain " + x);
      x.oneFourth();
      System.out.println("One fourth is " + x);
      x.oneFourth();
      System.out.println("One fourth is " + x);
   }
}
