/** split a chain into two */

package dataStructures;

public class ChainWithSplit extends Chain
{
   /** split this into lists a and b, this becomes empty following the split */
   public void split(ChainWithSplit a, ChainWithSplit b)
   {
      // handle this.size < 2 as special cases
      if (size < 2)
      {
         if (size == 0)
         {// both a and b are empty
            a.firstNode = b.firstNode = null;
            a.size = b.size = 0;
            return;
         }

         // size = 1
         // a gets the element, this and b become empty
         a.firstNode = firstNode;
         a.size = 1;
         firstNode = b.firstNode = null;
         size = b.size = 0;
         return;
      }

      // length is >= 2, assign a and b their first nodes
      a.firstNode = firstNode;
      b.firstNode = firstNode.next;
   
      // assign remaining nodes
      ChainNode ct = b.firstNode.next,   // cursor for this
                lastA = a.firstNode,     // last node in a
                lastB = b.firstNode;     // last node in b
      int numberOfPairs = size / 2;
      for (int i = 1; i < numberOfPairs; i++)
      {
         // first give a node to a
         lastA.next = ct;
         lastA = ct;
         ct = ct.next;

         // now give a node to b
         lastB.next = ct;
         lastB = ct;
         ct = ct.next;
      }
   
      // finish up
      lastA.next = ct;  // may be one element left in this
      lastB.next = null;

      // set size values for a and b
      b.size = size / 2;
      a.size = size - b.size;
   
      // this is now empty
      firstNode = null;
      size = 0;
   
      return;
   }

   /** test program */
   public static void main(String [] args)
   {
      ChainWithSplit x =new ChainWithSplit();
      ChainWithSplit y =new ChainWithSplit();
      ChainWithSplit z =new ChainWithSplit();
      
      //  try list sizes 0 through 7
      for (int n = 0; n < 8; n++)
      {
         // put elements in x
         for (int i = 0; i < n; i++)
            x.add(i, new Integer(i));
         
         System.out.println("The list is " + x);
         x.split(y, z);
         System.out.println("The split lists are " + y + "\nand " + z);
         System.out.println();
      }
   }
}
