

/** reverse a circular list */

package dataStructures;

public class CircularListWithReverse
       extends CircularList
{
   /** reverse the linear list */
   public void reverse()
   {
      if (lastNode == null) 
         return;    // empty list
   
      ChainNode previousNode = lastNode,
                currentNode = lastNode.next,
                newLastNode = currentNode,
                nextNode;
      while (currentNode != lastNode)
      {// change pointer direction
         nextNode = currentNode.next;
         currentNode.next = previousNode;
   
         // move to next node
         previousNode = currentNode;
         currentNode = nextNode;
      }
      currentNode.next = previousNode;
      lastNode = newLastNode;
   }


   /** test program */
   public static void main(String [] args)
   {
      int n = 10, m = 5;
      CircularListWithReverse x =
         new CircularListWithReverse();
      CircularListWithReverse y =
         new CircularListWithReverse();
      
      //  put elements in x
      for (int i = 0; i < n; i++)
         x.add(0, new Integer(4 * n - i));
      
      //  put elements in y
      for (int i = 0; i < m; i++)
         y.add(0, new Integer(2 * (n - i)));
      
      System.out.print("The reverse of " + x + " is ");
      x.reverse();
      System.out.println(x);
      System.out.print("The reverse of " + y + " is ");
      y.reverse();
      System.out.println(y);


      // remove a few elements from the end of x
      x.remove(x.size() - 1);
      x.remove(x.size() - 1);
      x.remove(x.size() - 1);
      x.remove(x.size() - 1);

      // add a few more at the front
      for (int i = 0; i < n; i++)
         x.add(0, new Integer(2 * n - i));

      System.out.print("The reverse of " + x + " is ");
      x.reverse();
      System.out.println(x);
   }
}
