
/** convert a double into an integer suitable for use by a hash function */

package dataStructures;

public class ConvertDouble
{
   /** covert theDouble into an integer */
   public static int integer(double theDouble)
   {
      // convert to IEEE standard 64-bit layout
      long theLong = Double.doubleToLongBits(theDouble);

      // fold into a 32-bit integer by taking the exclusive or
      // of two 32-bit segments
      int answer = (int) (theLong ^ (theLong >> 32));

      // return a nonnegative value
      return (answer < 0) ? -answer : answer;
   }

   /** test program */
   public static void main(String [] args)
   {
       double d = 2.345;
       System.out.println("The double is " + d);
       System.out.println("The corresponding integer is " +  integer(d));
   }
}
