

/** a stack class that is derived from ArrayDeque */

package dataStructures;

import java.util.EmptyStackException;

public class DequeStack extends ArrayDeque
                        implements Stack
{
   // constructors
   /** create a stack with the given initial capacity
     * @throws IllegalArgumentException when initialCapacity < 1 */
   public DequeStack(int initialCapacity)
      {super(initialCapacity);}

   /** create a stack with initial capacity 10 */
   public DequeStack()
      {this(10);}

   // methods
   /** @return true iff stack is empty */
   public boolean empty()
      {return isEmpty();}


   /** @return top element of stack
     * @throws EmptyStackException when the stack is empty */
   public Object peek()
   {
      if (empty())
         throw new EmptyStackException();
      return getRightElement();
   }

   /** add theElement to the top of the stack */
   public void push(Object theElement)
      {putAtRight(theElement);}

   /** remove top element of stack and return it
     * @throws EmptyStackException when the stack is empty */
   public Object pop()
   {
      if (empty())
         throw new EmptyStackException();
      return removeFromRight();
   }
   
   /** test program */
   public static void main(String [] args)
   {  
      int x;
      DequeStack s = new DequeStack(3);
      // add a few elements
      s.push(new Integer(1));
      s.push(new Integer(2));
      s.push(new Integer(3));
      s.push(new Integer(4));


      // delete all elements
      while (!s.empty())
      {
         System.out.println("Top element is " + s.peek());
         System.out.println("Removed the element " + s.pop());
      }
   }  
}
