

/** extension of DoubleCircularList to include the method reverse */

package dataStructures;

public class DoubleCircularListWithReverse
             extends DoubleCircularList
{
   /** in-place reversal of a doubly linked circular list */
   public void reverse()
   {
      if (size < 2)
         return;

      // swap pointers in each node
      DoubleNode currentNode = lastNode.next;
      while (currentNode != lastNode)
      {
         // change pointer directions
         DoubleNode nextNode = currentNode.next;
         currentNode.next = currentNode.previous;
         currentNode.previous = nextNode;
   
         // move to next node
         currentNode = nextNode;
      }
      
      // change pointer directions in last node
      DoubleNode nextNode = currentNode.next;
      currentNode.next = currentNode.previous;
      currentNode.previous = nextNode;

      // set new last node
      lastNode = lastNode.previous;
   }
   
   /** test program */
   public static void main(String [] args)
   {
      DoubleCircularListWithReverse c =
                    new DoubleCircularListWithReverse();
      int n = 10;

      // put n elements into c
      for (int i = 0; i < n; i++)
         c.add(i, new Integer(i));
      System.out.println("The list is " + c);

      // reverse the list
      c.reverse();
      System.out.println("The reversed list is " + c);
   }
}
