/** join two doubly linked lists */

package dataStructures;

public class DoublyLinkedListWithJoin extends DoublyLinkedList
{
   /** append list a to this
     * following the join, a is empty */
   public void join(DoublyLinkedListWithJoin a)
   {
      // special cases
      if (a.size == 0)
         // a is empty, nothing to join to this
         return;

      if (size == 0)
      {// this is empty,
         // move all nodes of a to this
         firstNode = a.firstNode;
         lastNode = a.lastNode;
         size = a.size;

         // make a empty
         a.clear();

         return;
      }
   
      // neither this nor a is empty
      // link a into end of this
      lastNode.next = a.firstNode;
      a.firstNode.previous = lastNode;
      lastNode = a.lastNode;
      size += a.size;

      // make a empty
      a.clear();

      return;
   }

   /** test program */
   public static void main(String [] args)
   {
      int n = 8, m = 5;
      DoublyLinkedListWithJoin x = new DoublyLinkedListWithJoin();
      DoublyLinkedListWithJoin y = new DoublyLinkedListWithJoin();
      DoublyLinkedListWithJoin z = new DoublyLinkedListWithJoin();
      
      //  put elements in x
      for (int i = 0; i < n; i++)
         x.add(0, new Integer(2 * (n - i)));
      
      //  put elements in y
      for (int i = 0; i < m; i++)
         y.add(0, new Integer(2 * (n - i) - 1));
      
      System.out.println("First list is " + z);
      System.out.println("Second list is " + y);
      z.join(y);
      System.out.println("Joined list is " + z);
      System.out.println("Second list is " + y);
      System.out.println();

      System.out.println("First list is " + x);
      System.out.println("Second list is " + y);
      x.join(y);
      System.out.println("Joined list is " + x);
      System.out.println();
      
      System.out.println("First list is " + z);
      System.out.println("Second list is " + x);
      z.join(x);
      System.out.println("Joined list is " + z);
      System.out.println("Second list is " + x);
      System.out.println();
   }
}
