/** extension of AdjacencyDigraph to include an input method */

package dataStructures;

import wrappers.*;
import utilities.*;
import exceptions.*;

public class ExtendedAdjacencyDigraph extends AdjacencyDigraph
{
   // constructors
   public ExtendedAdjacencyDigraph(int theVertices)
      {super(theVertices);}
   
   // default is a 0 vertex graph
   public ExtendedAdjacencyDigraph()
      {super(0);}
   
   /** input a digraph and store as this
     * @param inStream input stream for input */
   public void input(MyInputStream inStream)
   {
      // input number of vertices and edges
      System.out.println("Enter the number of vertices in the digraph");
      n = inStream.readInteger();
      if (n < 0)
         throw new MyInputException
                   ("number of vertices must be >= 0");

      System.out.println("Enter the number of edges in the digraph");
      int numOfEdges = inStream.readInteger();
      if (numOfEdges < 0)
         throw new MyInputException
                   ("number of edges must be >= 0");

      if (numOfEdges > n * (n - 1))
         throw new MyInputException("too many edges");

      // create a new 2D array a[][], initial values are null
      a = new boolean [n + 1][n + 1];
      e = 0;    // reset current number of edges to zero
   
      // now input the edges and add them to a[][]
      Edge newEdge = new Edge(0, 0);
      for (int i = 1; i <= numOfEdges; i++)
      {
         System.out.println("Enter edge " + i);
         newEdge.vertex1 = inStream.readInteger();
         newEdge.vertex2 = inStream.readInteger();
         putEdge(newEdge);
      }
   }

   /** test program */
   public static void main(String [] args)
   {
      // define an input stream to read from
      MyInputStream keyboard = new MyInputStream();

      // create digraph that is to be input
      ExtendedAdjacencyDigraph g = new ExtendedAdjacencyDigraph(4);

      // 2 digraphs
      for (int i = 1; i <= 2; i++)
      {
         // input the digraph
         g.input(keyboard);
   
         // output the digraph
         System.out.println("The number of vertices is " + g.vertices());
         System.out.println("The number of edges is " + g.edges());
         System.out.println("The graph is");
         g.output();
         System.out.println();
         System.out.println();
      }
   }
}
