
/** clone a formula-based binary tree, does not actually clone the elements */

package dataStructures;

import utilities.*;

public class FormulaBasedBinaryTree
             implements CloneableObject
{
   // data members
   Object [] element;   // array of tree elements
   int last;            // position of last element

   // constructors
   public FormulaBasedBinaryTree(Object [] theElement, int theLast)
   {
      element = theElement;
      last = theLast;
   }

   /** @return clone of the binary tree theTree */
   public Object clone()
   {
      // create a clone of element array
      Object [] cloneElement = new Object [element.length];
      for (int i = 1; i <= last; i++)
         cloneElement[i] = element[i];

      return new FormulaBasedBinaryTree(cloneElement, last);
   }

   /** test program */
   public static void main(String [] args)
   {
      Integer [] a = new Integer [15];
      a[1] = new Integer(1);
      a[2] = new Integer(2);
      a[5] = new Integer(5);
      a[10] = new Integer(10);
      a[11] = new Integer(11);

      FormulaBasedBinaryTree tree = new FormulaBasedBinaryTree(a, 11);
      // output original tree
      System.out.print("The original tree is ");
      for (int i = 1; i <= 11; i++)
         System.out.print(tree.element[i] + " ");
      System.out.println();
      System.out.println();

      // create and output the clone
      FormulaBasedBinaryTree cloneTree = (FormulaBasedBinaryTree) tree.clone();
      System.out.print("The cloned tree is ");
      for (int i = 1; i <= 11; i++)
         System.out.print(cloneTree.element[i] + " ");
      System.out.println();
      System.out.println();
   }
}
