
/** clone a linear list represented using Equation 3.1
  * each element in the list is also cloned */

package dataStructures;

import wrappers.*;
import utilities.*;

public class FormulaBasedLinearListWithClone
       extends FormulaBasedLinearList
       implements CloneableObject
{
   /** @return a clone of the linear list */
   public Object clone()
   {// overrides Object.clone()
      FormulaBasedLinearListWithClone x =
                        new FormulaBasedLinearListWithClone(); 
      x.size = size;
      x.element = new Object [element.length];
      for (int i = 0; i < size; i++)
         x.element[i] = ((CloneableObject) element[i]).clone();

      return x;
   }


   /** test program */
   public static void main(String [] args)
   {
      int n = 10;
      FormulaBasedLinearListWithClone x =
         new FormulaBasedLinearListWithClone();
      FormulaBasedLinearListWithClone y =
         new FormulaBasedLinearListWithClone();
      
      //  put elements in x
      for (int i = 0; i < n; i++)
         x.insertElementAt(new MyInteger(i), 0);
      
      System.out.println("The clone of " + x + " is ");
      y = (FormulaBasedLinearListWithClone) x.clone();
      System.out.println(y);
      x.insertElementAt(new MyInteger(3), 2);
      System.out.println("Changed original, clone should be unchanged.");
      System.out.println("Clone is " + y);
   }
}
