/** split a formula-based linear list into two */

package dataStructures;

import utilities.*;

public class FormulaBasedLinearListWithSplit
       extends FormulaBasedLinearList
{
   /** split this into lists a and b */
   public void split(FormulaBasedLinearListWithSplit a,
                     FormulaBasedLinearListWithSplit b)
   {
      // compute size of each split list, note that b.size
      // is 1 less than a.size when this.size is odd
      b.size = size / 2;
      a.size = size - b.size;

      // make sure each has enough space
      if (a.element.length < a.size)
         a.element = new Object [a.size];
      if (b.element.length < b.size)
         b.element = new Object [b.size];
      
      int ct = 0;         // cursor for this
      for (int i = 0; i < b.size; i++)
      {
         a.element[i] = element[ct++];
         b.element[i] = element[ct++];
      }
      
      // is an element left?
      if (a.size > b.size)
         a.element[a.size - 1] = element[ct];
   }

   /** test program */
   public static void main(String [] args)
   {
      FormulaBasedLinearListWithSplit x =
                  new FormulaBasedLinearListWithSplit();
      FormulaBasedLinearListWithSplit y =
                  new FormulaBasedLinearListWithSplit();
      FormulaBasedLinearListWithSplit z =
                  new FormulaBasedLinearListWithSplit();
      
      //  first try a list with even size
      int n = 10;
      // put elements in x
      for (int i = 0; i < n; i++)
         x.insertElementAt(new Integer(i), i);
      
      System.out.println("The list is " + x);
      x.split(y, z);
      System.out.println("The split lists are " + y + "\nand " + z);
      System.out.println();
      
      //  now try a list with odd size
      // put one more element into x
      x.insertElementAt(new Integer(n), n);
      
      System.out.println("The list is " + x);
      x.split(y, z);
      System.out.println("The split lists are " + y + "\nand " + z);
      System.out.println();
   }
}
