/** split a circular list with head node into two */

package dataStructures;

public class HeadCircularListWithSplit extends HeadCircularList
{
   /** split this into lists a and b, this becomes empty following the split */
   public void split(HeadCircularListWithSplit a, HeadCircularListWithSplit b)
   {
      ChainNode ct = headerNode.next;    // cursor for this
      a.lastNode = a.headerNode;         // last node in a
      b.lastNode = b.headerNode;         // last node in b
      while (ct != headerNode)
      {
         // first give a node to a
         a.lastNode.next = ct;
         a.lastNode = ct;
         ct = ct.next;
         if (ct == headerNode)
            break;

         // now give a node to b
         b.lastNode.next = ct;
         b.lastNode = ct;
         ct = ct.next;
      }
   
      // close the circular lists
      a.lastNode.next = a.headerNode;
      b.lastNode.next = b.headerNode;

      // set size values for a and b
      b.size = size / 2;
      a.size = size - b.size;
   
      // this is now empty
      clear();
   
      return;
   }


   /** test program */
   public static void main(String [] args)
   {
      HeadCircularListWithSplit x =new HeadCircularListWithSplit();
      HeadCircularListWithSplit y =new HeadCircularListWithSplit();
      HeadCircularListWithSplit z =new HeadCircularListWithSplit();
      
      //  try list sizes 0 through 7
      for (int n = 0; n < 8; n++)
      {
         // put elements in x
         for (int i = 0; i < n; i++)
            x.add(i, new Integer(i));
         
         System.out.println("The list is " + x);
         x.split(y, z);
         System.out.println("The split lists are " + y + "\nand " + z);
         System.out.println();
      }
   }
}
