

/** extension of HeadDoubleCircularList to include the method reverse */

package dataStructures;

public class HeadDoubleCircularListWithReverse
             extends HeadDoubleCircularList
{
   /** in-place reversal of a doubly linked circular list */
   public void reverse()
   {
      // swap pointers in each node
      DoubleNode currentNode = headerNode.next;
      while (currentNode != headerNode)
      {
         // change pointer directions
         DoubleNode nextNode = currentNode.next;
         currentNode.next = currentNode.previous;
         currentNode.previous = nextNode;
   
         // move to next node
         currentNode = nextNode;
      }
      
      // change pointer directions in header node
      DoubleNode nextNode = headerNode.next;
      headerNode.next = headerNode.previous;
      headerNode.previous = nextNode;
   }
   
   /** test program */
   public static void main(String [] args)
   {
      HeadDoubleCircularListWithReverse c =
                    new HeadDoubleCircularListWithReverse();
      int n = 10;

      // put n elements into c
      for (int i = 0; i < n; i++)
         c.add(i, new Integer(i));
      System.out.println("The list is " + c);

      // reverse the list
      c.reverse();
      System.out.println("The reversed list is " + c);
   }
}
