

/** extension of HeadDoubleCircularList to include the method reverse,
  * reversal is done by swapping elements rather than pointers */

package dataStructures;

public class HeadDoubleCircularListWithReverse2
             extends HeadDoubleCircularList
{
   /** in-place reversal of a doubly linked circular list */
   public void reverse()
   {
      int numberToSwap = size / 2;

      // swap numberToSwap pairs of elements
      DoubleNode leftSwapNode = headerNode.next;
      DoubleNode rightSwapNode = headerNode.previous;
      for (int i = 0; i < numberToSwap; i++)
      {
         // swap a pair
         Object temp = leftSwapNode.element;
         leftSwapNode.element = rightSwapNode.element;
         rightSwapNode.element = temp;
   
         // move to next pair
         leftSwapNode = leftSwapNode.next;
         rightSwapNode = rightSwapNode.previous;
      }
   }
   
   /** test program */
   public static void main(String [] args)
   {
      HeadDoubleCircularListWithReverse2 c =
                    new HeadDoubleCircularListWithReverse2();
      int n = 10;

      // put n elements into c
      for (int i = 0; i < n; i++)
         c.add(i, new Integer(i));
      System.out.println("The list is " + c);

      // reverse the list
      c.reverse();
      System.out.println("The reversed list is " + c);
   }
}
