/** split a doubly linked circular list with a header node into two */

package dataStructures;

public class HeadDoubleCircularListWithSplit extends HeadDoubleCircularList
{
   /** split this into lists a and b,
     * this becomes empty following the split */
   public void split(HeadDoubleCircularListWithSplit a,
                     HeadDoubleCircularListWithSplit b)
   {
      DoubleNode lastA = a.headerNode;  // last node in A
      DoubleNode lastB = b.headerNode;  // last node in B
      DoubleNode ct = headerNode.next;      // cursor for this
      while (ct != headerNode)
      {
         // first give a node to a
         lastA.next = ct;
         ct.previous = lastA;
         lastA = ct;
         ct = ct.next;
         if (ct == headerNode)
            break;

         // now give a node to b
         lastB.next = ct;
         ct.previous = lastB;
         lastB = ct;
         ct = ct.next;
      }
   
      // close the circles
      lastA.next = a.headerNode;
      a.headerNode.previous = lastA;
      lastB.next = b.headerNode;
      b.headerNode.previous = lastB;

      // set size values for a and b
      b.size = size / 2;
      a.size = size - b.size;
   
      // this is now empty
      clear();
   
      return;
   }

   /** test program */
   public static void main(String [] args)
   {
      HeadDoubleCircularListWithSplit x =new HeadDoubleCircularListWithSplit();
      HeadDoubleCircularListWithSplit y =new HeadDoubleCircularListWithSplit();
      HeadDoubleCircularListWithSplit z =new HeadDoubleCircularListWithSplit();
      
      //  try list sizes 0 through 7
      for (int n = 0; n < 8; n++)
      {
         // put elements in x
         for (int i = 0; i < n; i++)
            x.add(i, new Integer(i));
         
         System.out.println("The list is " + x);
         x.split(y, z);
         System.out.println("The split lists are " + y + "\nand " + z);
         System.out.println();
      }
   }
}
