
/** iterative inorder traversal of a binary tree */

package dataStructures;

public class IterativeInorderTraversal
{
   /** visit method that prints the element in the node */ 
   public static void visit(BinaryTreeNode t)
      {System.out.print(t.element + " ");}

   /** inorder traversal */
   public static void inOrder(BinaryTreeNode t)
   {
      ArrayStack stack = new ArrayStack(10);
      BinaryTreeNode currentNode = t;
      while (true)
      {// traverse subtree rooted at currentNode in inorder
   
         // make as many leftChild moves as possible
         while (currentNode != null)
         {
            stack.push(currentNode);
            currentNode = currentNode.leftChild;
         }
   
         // back up to last node
         try
         {
            currentNode = (BinaryTreeNode) stack.pop();
         }
         catch (Exception e)
         {// no node to back up to
            return;
         }
   
         visit(currentNode);
   
         // move to right subtree
         currentNode = currentNode.rightChild;
      }
   }

   /** test program */
   public static void main(String [] args)
   {
      BinaryTreeNode y = new BinaryTreeNode(new Integer(4));
      BinaryTreeNode z = new BinaryTreeNode(new Integer(5));
      BinaryTreeNode x = new BinaryTreeNode(new Integer(2), y, z);
      BinaryTreeNode w = new BinaryTreeNode(new Integer(7));
      BinaryTreeNode v = new BinaryTreeNode(new Integer(6), null, w);
      y = new BinaryTreeNode(new Integer(3), v, null);
      z = new BinaryTreeNode(new Integer(1), x, y);

      System.out.println("The elements in inorder are");
      inOrder(z);
      System.out.println();
   }
}
