/** LinkedDigraph extension that includes depth-first search */

package dataStructures;

import java.util.*;
import utilities.*;

public class LinkedDigraphWithDfs extends LinkedDigraph
{
   // constructors
   public LinkedDigraphWithDfs(int theVertices)
      {super(theVertices);}
   
   // default is a 0-vertex graph
   public LinkedDigraphWithDfs()
      {this(0);}
   
   /** depth-first search
     * reach[i] is set to label for all vertices reachable
     * from vertex v */
   static int [] reach;
   static int label;
   public void dfs(int v, int [] reach, int label)
   {
      LinkedDigraphWithDfs.reach = reach;
      LinkedDigraphWithDfs.label = label;
      rDfs(v);
   }
   
   /** recursive dfs method */
   private void rDfs(int v)
   {
      reach[v] = label;
      // go down the adjacency list of vertex v
      ChainNode currentNode = aList[v].firstNode;
      while (currentNode != null)
      {// visit an adjacent vertex of v
         int u = ((EdgeNode) currentNode.element).vertex; 
         if (reach[u] == 0)  // u is an unreached vertex
            rDfs(u);
         currentNode = currentNode.next;
      }
   }

   public static void main(String [] args)
   {
      LinkedDigraphWithDfs g = new LinkedDigraphWithDfs(7);
      int n = 7;
      int [] reach = new int [n + 1];

      // define a MyInputStream object to input from System.in
      MyInputStream keyboard = new MyInputStream();

      // input a test graph
      System.out.println("enter number of edges in graph");
      int e = keyboard.readInteger();
      for (int i = 1; i <= e; i++)
      {
         System.out.println("enter edge " + i);
         int u = keyboard.readInteger();
         int v = keyboard.readInteger();
         g.putEdge(new Edge(u, v));
      }
      System.out.println("The digraph is");
      g.output();

      g.dfs(1, reach, 1);
      System.out.print("Reached values for vertices are ");
      for (int j = 1; j <= n; j++)
         System.out.print(reach[j] + " ");
      System.out.println();
   }
}
