

/** a linked queue class derived from the class ExtendedChain */

package dataStructures;

public class LinkedQueueFromExtendedChain extends ExtendedChain
                                          implements Queue
{
   // constructors
   /** create an empty queue */
   public LinkedQueueFromExtendedChain()
      {super();}

   // method isEmpty is inherited from ExtendedChain

   // remaining methods of Queue follow

   /** @return the element at the front of the queue
     * @return null if the queue is empty */
   public Object getFrontElement()
   {
      if (isEmpty())
         return null;
      else
         return firstNode.element;
   }

   /** @return the element at the rear of the queue
     * @return null if the queue is empty */
   public Object getRearElement()
   {
      if (isEmpty())
         return null;
      else
         return lastNode.element;
   }

   /** insert theElement at the rear of the queue */
   public void put(Object theElement)
      {add(theElement);}

   /** remove an element from the front of the queue
     * @return removed element
     * @return null if the queue is empty */
   public Object remove()
   {
      if (isEmpty())
         return null;
      Object frontElement = firstNode.element;
      remove(0);
      return frontElement;
   }
   
   /** test program */
   public static void main(String [] args)
   {  
      int x;
      LinkedQueueFromExtendedChain q = new LinkedQueueFromExtendedChain();
      // add a few elements
      q.put(new Integer(1));
      q.put(new Integer(2));
      q.put(new Integer(3));
      q.put(new Integer(4));

      // delete all elements
      while (!q.isEmpty())
      {
         System.out.println("Rear element is " + q.getRearElement());
         System.out.println("Front element is " + q.getFrontElement());
         System.out.println("Removed the element " + q.remove());
      }
   }  
}
