
/** transpose method added to Matrix */

package dataStructures;

import utilities.*;
import wrappers.*;

public class MatrixWithTranspose extends Matrix
{
   // constructor
   public MatrixWithTranspose(int theRows, int theColumns)
      {super(theRows, theColumns);}

   /** return the transpose of this */
   public MatrixWithTranspose transpose()
   {
      // create result matrix w
      MatrixWithTranspose w = new MatrixWithTranspose(cols, rows);

      // set up the transpose of this
      int ct = 0;  // next element to move into the transpose
      for (int i = 1; i <= rows; i++)
         for (int j = 1; j <= cols; j++)
            w.element[(j - 1) * rows + i - 1] = element[ct++];
   
      return w;
   }

   /** test program */
   public static void main(String [] args)
   {
      MatrixWithTranspose x = new MatrixWithTranspose(3,2);
      MyInteger q = null;
      for (int i = 1; i <= 3; i++)
         for (int j = 1; j <= 2; j++)
         {
            q = new MyInteger(2 * i + j);
            x.set(i, j, q);
         }

      System.out.println("Matrix x is");
      System.out.println(x);

      // test transpose
      MatrixWithTranspose y = x.transpose();
      System.out.println("The transpose is");
      System.out.println(y);
   }
}
