   
/** max priority queue derived from SortedChainWithNoKey */

package dataStructures;

import java.util.*;

public class MaxPriorityQueueFromSortedChainWithNoKey
                        extends SortedChainWithNoKey
                        implements MaxPriorityQueue
{
   // constructors
   /** create a priority queue with the given initial capacity */
   public MaxPriorityQueueFromSortedChainWithNoKey(int initialCapacity)
      {super(initialCapacity);}
   
   /** create a priority queue with initial capacity 10 */
   public MaxPriorityQueueFromSortedChainWithNoKey()
      {super(10);}

   // methods isEmpty, size, and put are inherited from SortedChainWithNoKey

   /** @return maximum element
     * @return null if the priority queue is empty */
   public Comparable getMax()
   {
      if (size() == 0)
         // priority queue is empty
         return null;
   
      // use the iterator it to avoid accessing the data member firstNode
      Iterator it = iterator();
      return (Comparable) it.next();
   }

   /** remove max element and return it */
   public Comparable removeMax()
   {
      // if priority queue is empty return null
      if (size() == 0)
         return null;
   
      // get max element
      Iterator it = iterator();
      Comparable maxElement = (Comparable) it.next();

      // remove max element from priority queue
      remove(maxElement);
   
      return maxElement;
   }
   
   /** test program */
   public static void main(String [] args)
   {
      // test constructor and put
      MaxPriorityQueueFromSortedChainWithNoKey h =
                 new MaxPriorityQueueFromSortedChainWithNoKey(4);
      h.put(new Integer(10));
      h.put(new Integer(20));
      h.put(new Integer(5));
      h.put(new Integer(5));
      h.put(new Integer(20));
      h.put(new Integer(8));

      // test toString
      System.out.println("Elements in descending order are");
      System.out.println(h);
      System.out.println();

      h.put(new Integer(15));
      h.put(new Integer(30));

      System.out.println("Elements in descending order are");
      System.out.println(h);
      System.out.println();

      // test remove max
      System.out.println("The max element is " + h.getMax());
      System.out.println("Deleted max element " + h.removeMax());
      System.out.println("Deleted max element " + h.removeMax());
      System.out.println("Deleted max element " + h.removeMax());
      System.out.println("Deleted max element " + h.removeMax());
      System.out.println("Elements in descending order are");
      System.out.println(h);
      System.out.println();
   }
}
