
/** moving left and right on a chain */

package dataStructures;

public class MoveLeftAndRightOnAChain
{
   // data members
   ChainNode l, p;

   // constructor
   public MoveLeftAndRightOnAChain(Chain theChain)
   {
      p = theChain.firstNode;
      // default initial value of l is null
   }
   
   /** move p one node to the right */
   public void moveRight()
   {
      if (p != null)
      {// we can move right
         ChainNode t = p.next;

         // p should point to l
         p.next = l;

         // advance l and p
         l = p;
         p = t;
      }
      else
         // cannot move right
         throw new IllegalArgumentException
                   ("cannot move from null");
   }
   
   /** move p one node to the left */
   public void moveLeft()
   {
      if (l != null)
      {// can move left
         ChainNode t = l.next;

         // l should point to p
         l.next = p;

         // advance l and p
         p = l;
         l = t;
      }
      else
         // cannot move left
         throw new IllegalArgumentException
                   ("cannot move to null");
   }

   /** @return element at node p */
   public Object currentElement()
   {
      if (p != null)
         return p.element;
      else
         return null;
   }

   /** @return element at node l */
   public Object previousElement()
   {
      if (l != null)
         return l.element;
      else
         return null;
   }
   
   /** test program */
   public static void main(String [] args)
   {
      Chain x = new Chain();
  
      // insert a few elements
      x.add(0, new Integer(2));
      x.add(1, new Integer(6));
      x.add(0, new Integer(1));
      x.add(2, new Integer(4));
      x.add(2, new Integer(3));
      x.add(4, new Integer(5));

      System.out.println("The list is " + x);

      // output by using moveRight
      MoveLeftAndRightOnAChain m = new MoveLeftAndRightOnAChain(x);
      System.out.print("The list is ");
      while (m.currentElement() != null)
      {
         System.out.print((Integer) m.currentElement() + " ");
         m.moveRight();
      }
      System.out.println();

      // now output right to left
      System.out.print("The list, right to left, is ");
      while (m.previousElement() != null)
      {
         System.out.print((Integer) m.previousElement() + " ");
         m.moveLeft();
      }
      System.out.println();
   }
}
