/** linked binary trees with new makeTree that clones the subtrees */

package dataStructures;

public class NewLinkedBinaryTree extends LinkedBinaryTree
{
   /** @return clone of subtree with root t, elements are not cloned */
   BinaryTreeNode cloneSubtree(BinaryTreeNode t)
   {
      if (t == null)
         // empty subtree
         return null;
      else
         // nonempty subtree
         return new BinaryTreeNode(t.element,
                                   cloneSubtree(t.leftChild),
                                   cloneSubtree(t.rightChild));
   }

   /** set this to the tree with the given root and subtrees */
   public void makeTree(Object root, Object left, Object right)
   {
      this.root = new BinaryTreeNode(root,
                      cloneSubtree(((LinkedBinaryTree) left).root),
                      cloneSubtree(((LinkedBinaryTree) right).root));
   }

   /** test program */
   public static void main(String [] args)
   {
      NewLinkedBinaryTree a = new NewLinkedBinaryTree(),
                       x = new NewLinkedBinaryTree(), 
                       y = new NewLinkedBinaryTree(), 
                       z = new NewLinkedBinaryTree();
      y.makeTree(new Integer(1), a, a);
      z.makeTree(new Integer(2), a, a);
      x.makeTree(new Integer(3), y, z);
      y.makeTree(new Integer(4), x, x);

      System.out.println("Preorder sequence is ");
      y.preOrderOutput();
      System.out.println();

      System.out.println("Inorder sequence is ");
      y.inOrderOutput();
      System.out.println();

      System.out.println("Postorder sequence is ");
      y.postOrderOutput();
      System.out.println();

      System.out.println("Level order sequence is ");
      y.levelOrderOutput();
      System.out.println();

      System.out.println("Number of nodes = " + y.size());

      System.out.println("Height = " + y.height());
   }
}
