
/** bubble sort method to sort a simulated chain */

package dataStructures;

public class SimulatedChainWithBubbleSort extends SimulatedChain
{
   // constructors
   public SimulatedChainWithBubbleSort(int initialCapacity)
      {super(initialCapacity);}

   public SimulatedChainWithBubbleSort()
      {super();}

   // bubble sort
   /** bubble largest element in first n nodes to right */
   private void bubble(int n)
   {
      int currentNode = firstNode;
      for (int i = 0; i < n - 1; i++)
      {
         int nextNode = S.node[currentNode].next;
         if (((Comparable) S.node[currentNode].element)
               .compareTo(S.node[nextNode].element) > 0)
         {// swap elements
            Object temp = S.node[currentNode].element;
            S.node[currentNode].element = S.node[nextNode].element;
            S.node[nextNode].element = temp;
         }
         currentNode = nextNode;
      }
   }

   /** sort the array a using the bubble sort method */
   public void bubbleSort()
   {
      for (int i = size; i > 1; i--)
         bubble(i);
   }

   /** test program */
   public static void main(String [] args)
   {
      SimulatedChain.S = new SimulatedSpace1(100);
      SimulatedChainWithBubbleSort x = new SimulatedChainWithBubbleSort();
      x.add(0, new Integer(3));
      x.add(1, new Integer(2));
      x.add(2, new Integer(4));
      x.add(3, new Integer(1));
      x.add(4, new Integer(6));
      x.add(5, new Integer(9));
      x.add(6, new Integer(8));
      x.add(7, new Integer(7));
      x.add(8, new Integer(5));
      x.add(9, new Integer(0));
   
      // output elements to be sorted
      System.out.println("The elements are " + x);

      // sort the elements
      x.bubbleSort();

      // output in sorted order
      System.out.println("The sorted order is " + x);
   }
}
