
/** insertion sort method to sort a simulated chain */

package dataStructures;

public class SimulatedChainWithInsertionSort extends SimulatedChain
{
   // constructors
   public SimulatedChainWithInsertionSort(int initialCapacity)
      {super(initialCapacity);}

   public SimulatedChainWithInsertionSort()
      {super();}

   /** insertion sort */
   public void insertionSort()
   {
      int sFirstNode = -1;  // start of sorted chain

      // go down the unsorted chain inserting nodes into the sorted
      // chain that begins at sFirst
      while (firstNode != -1)
      {// a node remains in the unsorted chain
         // save pointer to next node in unsorted chain
         int nextNode = S.node[firstNode].next;
   
         // find place to insert firstNode in sorted chain
         int p = sFirstNode,  // current node
             tp = -1;         // tp trails p
         while (p != -1 &&
                ((Comparable) S.node[p].element).
                  compareTo(S.node[firstNode].element) < 0)
         {// move tp and p one node right
            tp = p;
            p = S.node[p].next;
         }
   
         // insert firstNode after tp
         if (tp != -1)
         {// not at front
            S.node[tp].next = firstNode;
            S.node[firstNode].next = p;
         }
         else
         {// insert at front
             sFirstNode = firstNode;
             S.node[firstNode].next = p;
         }
         
         // update firstNode
         firstNode = nextNode;
      }

      firstNode = sFirstNode;
   
      return;
   }

   /** test program */
   public static void main(String [] args)
   {
      SimulatedChain.S = new SimulatedSpace1(100);
      SimulatedChainWithInsertionSort x = new SimulatedChainWithInsertionSort();
      x.add(0, new Integer(3));
      x.add(1, new Integer(2));
      x.add(2, new Integer(4));
      x.add(3, new Integer(1));
      x.add(4, new Integer(6));
      x.add(5, new Integer(9));
      x.add(6, new Integer(8));
      x.add(7, new Integer(7));
      x.add(8, new Integer(5));
      x.add(9, new Integer(0));
   
      // output elements to be sorted
      System.out.println("The elements are " + x);

      // sort the elements
      x.insertionSort();

      // output in sorted order
      System.out.println("The sorted order is " + x);
   }
}
