
/** test Graph.shortestPaths */

// comment out the shortestPath code in adjacencyWDigraph before testing

package dataStructures;

import utilities.*;
import wrappers.*;

public class TestGraphShortestPaths
{
   public static void main(String [] args)
   {
      int numberOfTypes = 4;
      // create a graph of each weighted type
      Graph [] g = new Graph [numberOfTypes];

      // define a MyInputStream object to input from System.in
      MyInputStream keyboard = new MyInputStream();

      // input a test graph
      System.out.println("Enter number of vertices and edges");
      int n = keyboard.readInteger();
      int e = keyboard.readInteger();
      g[0] = new AdjacencyWGraph(n);
      g[1] = new AdjacencyWDigraph(n);
      g[2] = new LinkedWGraph(n);
      g[3] = new LinkedWDigraph(n);
      for (int i = 1; i <= e; i++)
      {
         System.out.println("enter weighted edge " + i);
         int u = keyboard.readInteger();
         int v = keyboard.readInteger();
         int w = keyboard.readInteger();
         g[0].putEdge(new WeightedEdge(u, v, new MyInteger(w)));
         g[1].putEdge(new WeightedEdge(u, v, new MyInteger(w)));
         g[2].putEdge(new WeightedEdge(u, v, new MyInteger(w)));
         g[3].putEdge(new WeightedEdge(u, v, new MyInteger(w)));
      }

      System.out.println("The weighted undirected graph is");
      ((AdjacencyWGraph) g[0]).output();
      System.out.println("\nThe weighted digraph is");
      ((AdjacencyWDigraph) g[1]).output();

      // test shortestPaths
      MyInteger [] dist = new MyInteger [n + 1];
      int [] p = new int [n + 1];
      g[0].shortestPaths(1, dist, p);
      System.out.println("The dist and p values for the adjacency "
                         + "undirected graph are");
      for (int i = 1; i <= n; i++)
         System.out.println(dist[i] + " " + p[i]);

      g[1].shortestPaths(1, dist, p);
      System.out.println("\nThe dist and p values for the "
                         + "adjacency directed graph are");
      for (int i = 1; i <= n; i++)
         System.out.println(dist[i] + " " + p[i]);

      g[2].shortestPaths(1, dist, p);
      System.out.println("\nThe dist and p values for the linked "
                         + "undirected graph are");
      for (int i = 1; i <= n; i++)
         System.out.println(dist[i] + " " + p[i]);

      g[3].shortestPaths(1, dist, p);
      System.out.println("\nThe dist and p values for the linked "
                         + "directed graph are");
      for (int i = 1; i <= n; i++)
         System.out.println(dist[i] + " " + p[i]);
   }
}
