/** test Graph.longestPath */

package dataStructures;

import utilities.*;
import wrappers.*;

public class TestLongestPath
{
   public static void main(String [] args)
   {
      // define a MyInputStream object to input from System.in
      MyInputStream keyboard = new MyInputStream();
      // try three weighted digraphs
      for (int q = 1; q <= 3; q++)
      {
         // input a test graph
         System.out.println("Enter number of vertices in weighted digraph");
         int n = keyboard.readInteger();

         LinkedWDigraph g = new LinkedWDigraph(n);

         System.out.println("Enter number of edges in weighted digraph");
         int e = keyboard.readInteger();
         for (int i = 1; i <= e; i++)
         {
            System.out.println("Enter edge " + i + " and its weight");
            int u = keyboard.readInteger();
            int v = keyboard.readInteger();
            int w = keyboard.readInteger();
            g.putEdge(new WeightedEdge(u, v, new MyInteger(w)));
         }
         System.out.println("The input weighted digraph is");
         g.output();

         // find the length of the longest path
         MyInteger [] l = new MyInteger [n + 1];
         int [] kay = new int [n + 1];
         int length = ((MyInteger) g.longestPath(l, kay,
                                     new MyInteger(0))).intValue();

         System.out.println("The length of the longest path is " + length);

         // output the longest path
         g.outputLongestPath(l, kay);
      }   
   }   
}
