
/** time for Graph.dfs, AdjacencyDigraphWithDfs.dfs
  * and LinkedDigraphWithDfs.dfs */

package misc;

import java.util.*;
import dataStructures.*;

public class TimeDfs
{
   public static void main(String [] args)
   {
      Graph [] g = new Graph[3];
      int n = 100;
      g[0] = new LinkedDigraphWithDfs(n);
      g[1] = new AdjacencyDigraphWithDfs(n);
      g[2] = new LinkedGraph(n);
      int [] reached = new int [n + 1];
     
      // set up complete graph
      for (int i = 1; i <= n; i++)
         for (int j = i + 1; j <= n; j++)
         {
            g[0].putEdge(new Edge(i, j));
            g[1].putEdge(new Edge(i, j));
            g[2].putEdge(new Edge(i, j));
         }

      long startTime = System.currentTimeMillis();
      // repeat many times
      int numTimes = 1000;
      for (int r = 1; r <= numTimes; r++)
      {
         for (int i = 1; i <= n; i++)
            reached[i] = 0;
         g[0].dfs(1, reached, 1);
      }
      double elapsedTime = System.currentTimeMillis() - startTime;
      System.out.println("Time for LinkedDigraphWithDfs.dfs is "
                         + elapsedTime/numTimes + " ms");

      numTimes = 10000;
      startTime = System.currentTimeMillis();
      for (int r = 1; r <= numTimes; r++)
      {
         for (int i = 1; i <= n; i++)
            reached[i] = 0;
         g[1].dfs(1, reached, 1);
      }
      elapsedTime = System.currentTimeMillis() - startTime;
      System.out.println("Time for AdjacencyGraphWithDfs.dfs is "
                         + elapsedTime/numTimes + " ms");

      numTimes = 1000;
      startTime = System.currentTimeMillis();
      for (int r = 1; r <= numTimes; r++)
      {
         for (int i = 1; i <= n; i++)
            reached[i] = 0;
         g[2].dfs(1, reached, 1);
      }
      elapsedTime = System.currentTimeMillis() - startTime;
      System.out.println("Time for Graph.dfs is "
                         + elapsedTime/numTimes + " ms");
   }
}
