

/** average run time of insertion sort */

package misc;

import java.util.*;
import applications.*;
import utilities.*;

public class TimeInsertionSort6
{
   public static void main(String [] args)
   {
      int step = 10;
      Random r = new Random();

      System.out.println("The average times, in milliseconds, are");
      System.out.println("n \trepetitions \telapsed time \ttime/sort");
      for (int n = 0; n <= 1000; n += step)
      {
         // create element array
         Integer [] a = new Integer[n];

         // initialize data
         for (int i = 0; i < n; i++)
            a[i] = new Integer(i);

         long startTime = System.currentTimeMillis();
         long counter = 0;
         while (counter < 20 || System.currentTimeMillis( ) - startTime < 1000)
         {
            counter++;
            // randomly permute a
            for (int i = n-1; i > 0; i--)
            {
               // select an element from a[0] to a[i]
               int j = Math.abs(r.nextInt()) % (i + 1);

               // swap i and j
               MyMath.swap(a, i, j);
            }

            // sort the elements
            InsertionSort2.insertionSort(a);
         }

         long elapsedTime = System.currentTimeMillis() - startTime;
         System.out.println(n + "\t" + counter + "\t\t" +
            + elapsedTime + "\t\t" + ((float) elapsedTime)/counter);

         if (n == 100) step = 100;
      }
   }
}
