

/** time LinearListAsIndexedAVLtree operations */

package misc;

import dataStructures.*;
import utilities.*;
import wrappers.*;
import java.util.*;

public class TimeLinearListAsIndexedAVLtree
{
   public static void main(String [] args)
   {
      LinearListAsIndexedAVLtree s = new LinearListAsIndexedAVLtree();
      int n = 40000;  // number of operations
      MyInteger x = new MyInteger(2);

      System.out.println("Timing LinearListAsIndexedAVLtree");

      // at end test
      System.out.println("End times in progress");

      int m = 20;

      // insert n elements
      long startTime = System.currentTimeMillis();
      for (int k = 0; k < m; k++)
      {
         s = new LinearListAsIndexedAVLtree();
         for (int i = 0; i < n; i++)
           s.insertElementAt(x,i);
      }

      long elapsedTime = System.currentTimeMillis() - startTime;
      long insertTime = elapsedTime / m;
      System.out.println(s.size() + " inserts took " + insertTime +
                         " ms");


      // elementAt test
      startTime = System.currentTimeMillis();
      for (int k = 0; k < m; k++)
         for (int i = 0; i < n; i++)
           s.elementAt(i);

      elapsedTime = System.currentTimeMillis() - startTime;
      System.out.println(s.size() + " element ats took " + (elapsedTime / m) +
                         " ms");


      // now remove them
      startTime = System.currentTimeMillis();
      for (int k = 0; k < m; k++)
      {
         s = new LinearListAsIndexedAVLtree();
         for (int i = 0; i < n; i++)
           s.insertElementAt(x,i);
         for (int i = n-1; i >= 0; i--)
           s.removeElementAt(i);
      }

      elapsedTime = System.currentTimeMillis() - startTime;
      System.out.println(n + " removes took " + (elapsedTime / m - insertTime) +
                         " ms"); 


      // at front test
      System.out.println();
      System.out.println("Front times in progress");
      n = 40000;

      // insert n elements
      startTime = System.currentTimeMillis();
      for (int j = 0; j < m; j++)
      {
         s = new LinearListAsIndexedAVLtree();
         for (int i = 0; i < n; i++)
           s.insertElementAt(x,0);
      }

      elapsedTime = System.currentTimeMillis() - startTime;
      insertTime = elapsedTime / m;
      System.out.println(s.size() + " inserts took " + insertTime +
                         " ms");


      // now remove them
      startTime = System.currentTimeMillis();
      for (int j = 0; j < m; j++)
      {
         s = new LinearListAsIndexedAVLtree();
         for (int i = 0; i < n; i++)
           s.insertElementAt(x,0);
         for (int i = n-1; i >= 0; i--)
           s.removeElementAt(0);
      }


      elapsedTime = System.currentTimeMillis() - startTime;
      System.out.println(n + " removes took " + (elapsedTime / m - insertTime) +
                         " ms");

      // average-case test
      System.out.println();
      System.out.println("Average-case times in progress");
      Random r = new Random();
      n = 40000;


      // insert n elements
      startTime = System.currentTimeMillis();
      for (int k = 0; k < m; k++)
      {
         s = new LinearListAsIndexedAVLtree();
         for (int i = 0; i < n; i++)
         {
           int j = r.nextInt();
           if (j < 0)
             j = -j;
           j = j % (i + 1);
           s.insertElementAt(x,j);
         }
      }

      elapsedTime = System.currentTimeMillis() - startTime;
      insertTime = elapsedTime / m;
      System.out.println(s.size() + " inserts took " + insertTime +
                         " ms");



      // remove test
      startTime = System.currentTimeMillis();
      for (int k = 0; k < m; k++)
      {
         s = new LinearListAsIndexedAVLtree();
         // first insert
         for (int i = 0; i < n; i++)
         {
           int j = r.nextInt();
           if (j < 0)
             j = -j;
           j = j % (i + 1);
           s.insertElementAt(x,j);
         }
         // now remove them
         for (int i = n; i > 0; i--)
         {
           int j = r.nextInt();
           if (j < 0)
             j = -j;
           j = j % i;
           s.removeElementAt(j);
         }
      }

      elapsedTime = System.currentTimeMillis() - startTime;
      System.out.println(n + " removes took " + (elapsedTime / m - insertTime) +
                         " ms");


   }
}
